<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: KakaduImage.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('KakaduImage_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">KakaduImage.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Kakadu JPEG2000 Image class Interface</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">/*  IIP Kakadu JPEG2000 Class</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">    Development supported by Moravian Library in Brno (Moravska zemska</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">    knihovna v Brne, http://www.mzk.cz/) R&amp;D grant MK00009494301 &amp; Old</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">    Maps Online (http://www.oldmapsonline.org/) from the Ministry of</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">    Culture of the Czech Republic.</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">    Copyright (C) 2009-2017 IIPImage.</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">    Author: Ruven Pillay</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">    This program is free software; you can redistribute it and/or modify</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">    it under the terms of the GNU General Public License as published by</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">    the Free Software Foundation; either version 3 of the License, or</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">    (at your option) any later version.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">    This program is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">    GNU General Public License for more details.</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">    You should have received a copy of the GNU General Public License</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">    along with this program; if not, write to the Free Software Foundation,</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#ifndef _KAKADUIMAGE_H</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#define _KAKADUIMAGE_H</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &quot;IIPImage.h&quot;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &quot;Logger.h&quot;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;jpx.h&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;jp2.h&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;kdu_stripe_decompressor.h&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#define TILESIZE 256</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">// Kakadu 7.5 uses namespaces</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#if KDU_MAJOR_VERSION &gt; 7 || (KDU_MAJOR_VERSION == 7 &amp;&amp; KDU_MINOR_VERSION &gt;= 5)</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">using namespace </span>kdu_supp; <span class="comment">// Also includes the `kdu_core&#39; namespace</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">extern</span> <a class="code" href="classLogger.html">Logger</a> logfile;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classkdu__stream__message.html">   54</a></span>&#160;<span class="keyword">class </span><a class="code" href="classkdu__stream__message.html">kdu_stream_message</a> : <span class="keyword">public</span> kdu_message {</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; <span class="keyword">private</span>: <span class="comment">// Data</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  std::ostream *stream;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  std::string message;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; <span class="keyword">public</span>: <span class="comment">// Member classes</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  <a class="code" href="classkdu__stream__message.html">kdu_stream_message</a>(std::ostream *stream)</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    { this-&gt;stream = stream; }</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <span class="keywordtype">void</span> put_text(<span class="keyword">const</span> <span class="keywordtype">char</span> *<span class="keywordtype">string</span>)</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  { logfile &lt;&lt; string; }</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="keywordtype">void</span> flush(<span class="keywordtype">bool</span> end_of_message=<span class="keyword">false</span>){</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    logfile &lt;&lt; message;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">if</span>( end_of_message ) <span class="keywordflow">throw</span> 1;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  }</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;};</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">//static kdu_stream_message cout_message(&amp;std::cout);</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment">//static kdu_stream_message cerr_message(&amp;std::cerr);</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="keyword">static</span> <a class="code" href="classkdu__stream__message.html">kdu_stream_message</a> cout_message(&amp;logfile);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keyword">static</span> <a class="code" href="classkdu__stream__message.html">kdu_stream_message</a> cerr_message(&amp;logfile);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword">static</span> kdu_message_formatter pretty_cout(&amp;cout_message);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">static</span> kdu_message_formatter pretty_cerr(&amp;cerr_message);</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="classKakaduImage.html">   85</a></span>&#160;<span class="keyword">class </span><a class="code" href="classKakaduImage.html">KakaduImage</a> : <span class="keyword">public</span> <a class="code" href="classIIPImage.html">IIPImage</a> {</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  kdu_codestream codestream;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  kdu_compressed_source *input;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  jpx_source jpx_input;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;  jp2_family_src src;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;  jpx_codestream_source jpx_stream;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;  kdu_stripe_decompressor decompressor;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;  kdu_dims comp_dims;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;  <span class="keywordtype">void</span> process( <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r, <span class="keywordtype">int</span> l, <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> w, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> h, <span class="keywordtype">void</span>* d );</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;  <span class="keywordtype">void</span> delete_buffer( <span class="keywordtype">void</span>* b );</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="classKakaduImage.html#a0e8c3b55c7f276a1fc4ce4eb366f5e9b">  130</a></span>&#160;  <a class="code" href="classKakaduImage.html#a0e8c3b55c7f276a1fc4ce4eb366f5e9b">KakaduImage</a>(): <a class="code" href="classIIPImage.html">IIPImage</a>(){</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    tile_width = TILESIZE; tile_height = TILESIZE; input = NULL;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;  };</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="classKakaduImage.html#a1ec69ac644a1544001b9cb9eec3ae6df">  137</a></span>&#160;  <a class="code" href="classKakaduImage.html#a1ec69ac644a1544001b9cb9eec3ae6df">KakaduImage</a>( <span class="keyword">const</span> std::string&amp; path ): <a class="code" href="classIIPImage.html">IIPImage</a>( path ){</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    tile_width = TILESIZE; tile_height = TILESIZE; input = NULL;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;  };</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno"><a class="line" href="classKakaduImage.html#aeaa4a2b3830dff0c5ede621990b8473b">  144</a></span>&#160;  <a class="code" href="classKakaduImage.html#aeaa4a2b3830dff0c5ede621990b8473b">KakaduImage</a>( <span class="keyword">const</span> <a class="code" href="classKakaduImage.html">KakaduImage</a>&amp; image ): <a class="code" href="classIIPImage.html">IIPImage</a>( image ) {};</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="classKakaduImage.html#af6a8aa9a344cb32af4a88a05f17b8e4d">  149</a></span>&#160;  <a class="code" href="classKakaduImage.html#af6a8aa9a344cb32af4a88a05f17b8e4d">KakaduImage</a>( <span class="keyword">const</span> <a class="code" href="classIIPImage.html">IIPImage</a>&amp; image ): <a class="code" href="classIIPImage.html">IIPImage</a>( image ){</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    tile_width = TILESIZE; tile_height = TILESIZE; input = NULL;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;  };</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno"><a class="line" href="classKakaduImage.html#afb22dcbefd4567a45c5128f748831926">  156</a></span>&#160;  <a class="code" href="classKakaduImage.html">KakaduImage</a>&amp; operator = ( <a class="code" href="classKakaduImage.html">KakaduImage</a> image ) {</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordflow">if</span>( <span class="keyword">this</span> != &amp;image ){</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      closeImage();</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;      <a class="code" href="classIIPImage.html#a33361969aaa0f0c8a458859951b79c21">IIPImage::operator=</a>(image);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    }</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;  }</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno"><a class="line" href="classKakaduImage.html#a9d5b6087f11ab192b0fdc735322d3f67">  166</a></span>&#160;  <a class="code" href="classKakaduImage.html#a9d5b6087f11ab192b0fdc735322d3f67">~KakaduImage</a>() { closeImage(); };</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;  <span class="keywordtype">void</span> openImage();</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;  <span class="keywordtype">void</span> loadImageInfo( <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y );</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;  <span class="keywordtype">void</span> closeImage();</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="classKakaduImage.html#a0ed5ddf9e02b401fcf8dbf24838b7d95">  182</a></span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="classKakaduImage.html#a0ed5ddf9e02b401fcf8dbf24838b7d95">regionDecoding</a>(){ <span class="keywordflow">return</span> <span class="keyword">true</span>; };</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;  <a class="code" href="classRawTile.html">RawTile</a> getTile( <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r, <span class="keywordtype">int</span> l, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> t );</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;  <a class="code" href="classRawTile.html">RawTile</a> getRegion( <span class="keywordtype">int</span> ha, <span class="keywordtype">int</span> va, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r, <span class="keywordtype">int</span> l, <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> w, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> h );</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno"><a class="line" href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490">  208</a></span>&#160;  <span class="keyword">enum</span> <a class="code" href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490">KDU_READMODE</a> { KDU_FAST,     </div><div class="line"><a name="l00209"></a><span class="lineno"><a class="line" href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490a089f2b8dc378eb1bac90db23d605a25e">  209</a></span>&#160;                      <a class="code" href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490a089f2b8dc378eb1bac90db23d605a25e">KDU_FUSSY</a>,    </div><div class="line"><a name="l00210"></a><span class="lineno"><a class="line" href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490a2b092671045e62a86480aef882f00021">  210</a></span>&#160;                      KDU_RESILIENT </div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;  };</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00214"></a><span class="lineno"><a class="line" href="classKakaduImage.html#a043b1b8e649808c1d1b6bb174ca48731">  214</a></span>&#160;  <a class="code" href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490">KDU_READMODE</a> <a class="code" href="classKakaduImage.html#a043b1b8e649808c1d1b6bb174ca48731">kdu_readmode</a>;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;};</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classLogger_html"><div class="ttname"><a href="classLogger.html">Logger</a></div><div class="ttdoc">Logger class - handles ofstreams and syslog. </div><div class="ttdef"><b>Definition:</b> Logger.h:79</div></div>
<div class="ttc" id="classKakaduImage_html_a1ec69ac644a1544001b9cb9eec3ae6df"><div class="ttname"><a href="classKakaduImage.html#a1ec69ac644a1544001b9cb9eec3ae6df">KakaduImage::KakaduImage</a></div><div class="ttdeci">KakaduImage(const std::string &amp;path)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:137</div></div>
<div class="ttc" id="classKakaduImage_html_a043b1b8e649808c1d1b6bb174ca48731"><div class="ttname"><a href="classKakaduImage.html#a043b1b8e649808c1d1b6bb174ca48731">KakaduImage::kdu_readmode</a></div><div class="ttdeci">KDU_READMODE kdu_readmode</div><div class="ttdoc">Read-mode. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:214</div></div>
<div class="ttc" id="classKakaduImage_html_a0ed5ddf9e02b401fcf8dbf24838b7d95"><div class="ttname"><a href="classKakaduImage.html#a0ed5ddf9e02b401fcf8dbf24838b7d95">KakaduImage::regionDecoding</a></div><div class="ttdeci">bool regionDecoding()</div><div class="ttdoc">Return whether this image type directly handles region decoding. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:182</div></div>
<div class="ttc" id="classKakaduImage_html_a0e8c3b55c7f276a1fc4ce4eb366f5e9b"><div class="ttname"><a href="classKakaduImage.html#a0e8c3b55c7f276a1fc4ce4eb366f5e9b">KakaduImage::KakaduImage</a></div><div class="ttdeci">KakaduImage()</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:130</div></div>
<div class="ttc" id="classKakaduImage_html"><div class="ttname"><a href="classKakaduImage.html">KakaduImage</a></div><div class="ttdoc">Image class for Kakadu JPEG2000 Images: Inherits from IIPImage. Uses the Kakadu library. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:85</div></div>
<div class="ttc" id="classKakaduImage_html_aeaa4a2b3830dff0c5ede621990b8473b"><div class="ttname"><a href="classKakaduImage.html#aeaa4a2b3830dff0c5ede621990b8473b">KakaduImage::KakaduImage</a></div><div class="ttdeci">KakaduImage(const KakaduImage &amp;image)</div><div class="ttdoc">Copy Constructor. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:144</div></div>
<div class="ttc" id="classKakaduImage_html_ae38bdfee80f8ee9c993024918837f490a089f2b8dc378eb1bac90db23d605a25e"><div class="ttname"><a href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490a089f2b8dc378eb1bac90db23d605a25e">KakaduImage::KDU_FUSSY</a></div><div class="ttdoc">Fussy mode. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:209</div></div>
<div class="ttc" id="classKakaduImage_html_a9d5b6087f11ab192b0fdc735322d3f67"><div class="ttname"><a href="classKakaduImage.html#a9d5b6087f11ab192b0fdc735322d3f67">KakaduImage::~KakaduImage</a></div><div class="ttdeci">~KakaduImage()</div><div class="ttdoc">Destructor. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:166</div></div>
<div class="ttc" id="classIIPImage_html"><div class="ttname"><a href="classIIPImage.html">IIPImage</a></div><div class="ttdoc">Main class to handle the pyramidal image source. </div><div class="ttdef"><b>Definition:</b> IIPImage.h:62</div></div>
<div class="ttc" id="classkdu__stream__message_html"><div class="ttname"><a href="classkdu__stream__message.html">kdu_stream_message</a></div><div class="ttdoc">Wrapper class to handle error messages from Kakadu. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:54</div></div>
<div class="ttc" id="classIIPImage_html_a33361969aaa0f0c8a458859951b79c21"><div class="ttname"><a href="classIIPImage.html#a33361969aaa0f0c8a458859951b79c21">IIPImage::operator=</a></div><div class="ttdeci">IIPImage &amp; operator=(IIPImage image)</div><div class="ttdoc">Assignment operator. </div><div class="ttdef"><b>Definition:</b> IIPImage.h:375</div></div>
<div class="ttc" id="classRawTile_html"><div class="ttname"><a href="classRawTile.html">RawTile</a></div><div class="ttdoc">Class to represent a single image tile. </div><div class="ttdef"><b>Definition:</b> RawTile.h:45</div></div>
<div class="ttc" id="classKakaduImage_html_af6a8aa9a344cb32af4a88a05f17b8e4d"><div class="ttname"><a href="classKakaduImage.html#af6a8aa9a344cb32af4a88a05f17b8e4d">KakaduImage::KakaduImage</a></div><div class="ttdeci">KakaduImage(const IIPImage &amp;image)</div><div class="ttdoc">Constructor from IIPImage object. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:149</div></div>
<div class="ttc" id="classKakaduImage_html_ae38bdfee80f8ee9c993024918837f490"><div class="ttname"><a href="classKakaduImage.html#ae38bdfee80f8ee9c993024918837f490">KakaduImage::KDU_READMODE</a></div><div class="ttdeci">KDU_READMODE</div><div class="ttdoc">Read-mode types. </div><div class="ttdef"><b>Definition:</b> KakaduImage.h:208</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><b>KakaduImage.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
